

--   BookStore 8.3.6
--   BookStore.lua
--
--   Author      : Lemmoros, based on Bookstore by Ed Farrow (aka. Stormina Teacup)
--   Description : 
--                 BookStore is intended to help roleplayers by allowing
--                 them to save copies of in-game books for reading at a
--                 later date. This means that players can essentially
--                 'carry' books with them. Although they do not take up
--                 any real space.
--
local lbsr_pagestbl={}
local current_book = 0;
local lbsr_DeleteTitle = "";
local current_book_toEdit = 0;
local current_page = 0;
local current_shelf = 1;
-- 4x3 Bag Texture.
local BOOKS_PER_SHELF = 20;
-- Change this to enlarge or reduce your BookStore shelves. NOTE: Reducing your BookStore shelves doesn't delete your books.
local MAXIMUM_SHELVES = 100;
local MAXIMUM_BOOKS = BOOKS_PER_SHELF * MAXIMUM_SHELVES;
local BOOKSTORE_DEFAULT_BOOK_ICON = "Interface\\Icons\\INV_Misc_Book_09";
local edit_entrytitle = "";
local edit_entrytitle_check = "";
local edit_existing = false
local custom_BookTitle = false
local lbsr_IconCache = "";
local lbsr_AuthorCache = "";
local lbsr_TextureCache = "";
local lbsr_PagesCache = {};
local lbsr_optionsFrame = CreateFrame("FRAME")
local addonName = " |cffCE5C00Lemmo\'s|r |cff729FCFBookStore|r|cff73D216 reborn|r"

-- plain letter localization name

-- Letter title edit frames
lbsr_EditLetterTitle = CreateFrame("Frame", "LBSR_Letter-Title", UIParent, BackdropTemplateMixin and "BackdropTemplate")
--lbsr_EditLetterTitle:SetScript("OnLoad", function() tinsert(UISpecialFrames, lbsr_EditLetterTitle) end)
lbsr_EditLetterTitle:SetPoint("CENTER", 0, 0); lbsr_EditLetterTitle:SetWidth(600); lbsr_EditLetterTitle:SetHeight(158);
--lbsr_EditLetterTitle:SetFrameStrata("BACKGROUND")
lbsr_EditLetterTitle:SetToplevel(true)
lbsr_EditLetterTitle:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/backsmall",
	tile = false,
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
	edgeSize = 16,
	insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5,
	},
})

lbsr_EditLetterTitle:Hide()

local lbsr_InputBoxTitle = lbsr_EditLetterTitle:CreateFontString(nil, "OVERLAY", "GameFontNormalHugeBlack")
lbsr_InputBoxTitle:SetPoint("TOP", 0, -15)
lbsr_InputBoxTitle:SetTextColor(1, 1, 1, 1)
lbsr_InputBoxTitle:SetText(BOOKSTORE_TITLE_CHANGE)
--lbsr_InputBoxTitle:Show()

local lbsr_EditBackground = CreateFrame("Frame", "Background-Editbox", lbsr_EditLetterTitle, BackdropTemplateMixin and "BackdropTemplate")
lbsr_EditBackground:SetPoint("CENTER", 0, 0); lbsr_EditBackground:SetWidth(520); lbsr_EditBackground:SetHeight(32);
--lbsr_EditBackground:SetFrameStrata("DIALOG")
lbsr_EditBackground:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_InputBox = CreateFrame("EditBox", nil, lbsr_EditBackground)
lbsr_InputBox:SetMaxLetters(254)
lbsr_InputBox:SetPoint("CENTER", 0, 0)
lbsr_InputBox:SetSize(510, 32)
lbsr_InputBox:SetFont(ChatFontNormal:GetFont())
lbsr_InputBox:SetAutoFocus(true)
lbsr_InputBox:SetMultiLine(false)
lbsr_InputBox:SetScript("OnEscapePressed", function()
		lbsr_EditLetterTitle:Hide()
end)
lbsr_InputBox:SetScript("OnEnterPressed", function()
    lbsr_ChangeTitle()
end)
--lbsr_InputBox:Show()

local lbsr_OKButton = CreateFrame("Button", nil, lbsr_EditLetterTitle)
lbsr_OKButton = lbsr_OKButton
lbsr_OKButton:SetSize(128, 24)
lbsr_OKButton:SetPoint("BOTTOM", -136, 16)
lbsr_OKButton:SetText(OKAY)
-- Textures
lbsr_OKButton:SetNormalTexture(lbsr_OKButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr_OKButton:SetPushedTexture(lbsr_OKButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr_OKButton:SetHighlightTexture(lbsr_OKButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_OKButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_OKButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_OKButton:SetScript("OnClick", function()
    lbsr_ChangeTitle()
end)

local lbsr_CancelButton = CreateFrame("Button", nil, lbsr_EditLetterTitle)
lbsr_CancelButton = lbsr_CancelButton
lbsr_CancelButton:SetSize(128, 24)
lbsr_CancelButton:SetPoint("BOTTOM", 136, 16)
lbsr_CancelButton:SetText(CANCEL)
-- Textures
lbsr_CancelButton:SetNormalTexture(lbsr_CancelButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr_CancelButton:SetPushedTexture(lbsr_CancelButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr_CancelButton:SetHighlightTexture(lbsr_CancelButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_CancelButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_CancelButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_CancelButton:SetScript("OnClick", function()
	lbsr_EditLetterTitle:Hide()
end)

lbsr_EditLetterTitle:EnableMouse(true)
lbsr_EditLetterTitle:EnableKeyboard(true)

-- end Letter title edit frames

-- import database

lbsr_DB_Import_Title = CreateFrame("Frame", "LBSR_Import_DB", UIParent, BackdropTemplateMixin and "BackdropTemplate")
lbsr_DB_Import_Title:SetPoint("CENTER", 0, 0); lbsr_DB_Import_Title:SetWidth(600); lbsr_DB_Import_Title:SetHeight(175);
--lbsr_DB_Import_Title:SetFrameStrata("DIALOG")
lbsr_DB_Import_Title:SetToplevel(true)
lbsr_DB_Import_Title:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/backsmall",
	tile = false,
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
	edgeSize = 16,
	insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5,
	},
})

lbsr_DB_Import_Title:Hide()

local lbsr_DB_Import_Title_Text = lbsr_DB_Import_Title:CreateFontString(nil, "OVERLAY", "GameFontNormalHugeBlack")
lbsr_DB_Import_Title_Text:SetPoint("TOP", 0, -20)
lbsr_DB_Import_Title_Text:SetTextColor(1, 1, 1, 1)
lbsr_DB_Import_Title_Text:SetText(BOOKSTORE_IMPORT_DB_TEXT)

local lbsr__DB_Import_OKButton = CreateFrame("Button", nil, lbsr_DB_Import_Title)
lbsr__DB_Import_OKButton = lbsr__DB_Import_OKButton
lbsr__DB_Import_OKButton:SetSize(256, 64)
lbsr__DB_Import_OKButton:SetPoint("CENTER", -136, 5)
lbsr__DB_Import_OKButton:SetText(BOOKSTORE_IMPORT_DB_KNOWN_ONLY)
-- Textures
lbsr__DB_Import_OKButton:SetNormalTexture(lbsr__DB_Import_OKButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr__DB_Import_OKButton:SetPushedTexture(lbsr__DB_Import_OKButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr__DB_Import_OKButton:SetHighlightTexture(lbsr__DB_Import_OKButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr__DB_Import_OKButton:SetNormalFontObject(DialogButtonNormalText)
lbsr__DB_Import_OKButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr__DB_Import_OKButton:SetScript("OnClick", function()
    BookStore_ImportDB(false)
    lbsr_DB_Import_Title:Hide()
end)

local lbsr_DB_Import_ResetButton = CreateFrame("Button", nil, lbsr_DB_Import_Title)
lbsr_DB_Import_ResetButton = lbsr_DB_Import_ResetButton
lbsr_DB_Import_ResetButton:SetSize(256, 64)
lbsr_DB_Import_ResetButton:SetPoint("CENTER", 136, 5)
lbsr_DB_Import_ResetButton:SetText(BOOKSTORE_IMPORT_DB_RESET)
-- Textures
lbsr_DB_Import_ResetButton:SetNormalTexture(lbsr_DB_Import_ResetButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr_DB_Import_ResetButton:SetPushedTexture(lbsr_DB_Import_ResetButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr_DB_Import_ResetButton:SetHighlightTexture(lbsr_DB_Import_ResetButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_DB_Import_ResetButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_DB_Import_ResetButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_DB_Import_ResetButton:SetScript("OnClick", function()
    StaticPopup_Show("LBSR_RESET")
	lbsr_DB_Import_Title:Hide()
end)

local lbsr_DB_Import_CancelButton = CreateFrame("Button", nil, lbsr_DB_Import_Title)
lbsr_DB_Import_CancelButton = lbsr_DB_Import_CancelButton
lbsr_DB_Import_CancelButton:SetSize(160, 30)
lbsr_DB_Import_CancelButton:SetPoint("BOTTOM", 0, 16)
lbsr_DB_Import_CancelButton:SetText(CANCEL)
-- Textures
lbsr_DB_Import_CancelButton:SetNormalTexture(lbsr_DB_Import_CancelButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr_DB_Import_CancelButton:SetPushedTexture(lbsr_DB_Import_CancelButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr_DB_Import_CancelButton:SetHighlightTexture(lbsr_DB_Import_CancelButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_DB_Import_CancelButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_DB_Import_CancelButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_DB_Import_CancelButton:SetScript("OnClick", function()
	lbsr_DB_Import_Title:Hide()
end)

lbsr_DB_Import_Title:EnableMouse(true)
lbsr_DB_Import_Title:EnableKeyboard(true)

-- end import database

-- Letter Search frames
lbsr_SearchInput = CreateFrame("Frame", "LBSR_Search-Input", UIParent, BackdropTemplateMixin and "BackdropTemplate") lbsr_SearchInput:SetPoint("CENTER", 0, 0); lbsr_SearchInput:SetWidth(600); lbsr_SearchInput:SetHeight(600);
--lbsr_SearchInput:SetFrameStrata("DIALOG")
lbsr_SearchInput:SetToplevel(true)
lbsr_SearchInput:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/backbig",
	tile = false,
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
	edgeSize = 16,
	insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5,
	},
})

lbsr_SearchInput:Hide()



local lbsr_SearchInputboxTitle = lbsr_SearchInput:CreateFontString(nil, "OVERLAY", "GameFontNormalHugeBlack")
lbsr_SearchInputboxTitle:SetPoint("TOP", 0, -15)
lbsr_SearchInputboxTitle:SetTextColor(1, 1, 1, 1)
lbsr_SearchInputboxTitle:SetText(BOOKSTORE_SEARCH_FOR)
--lbsr_SearchInputboxTitle:Show()

local lbsr_SearchStatistics = lbsr_SearchInput:CreateFontString(nil, "OVERLAY", "GameFontNormal")
lbsr_SearchStatistics:SetPoint("TOPLEFT", 50, -80)
lbsr_SearchStatistics:SetTextColor(1, 1, 1, 1)
lbsr_SearchStatistics:SetText("")

local lbsr_SearchInputboxBackground = CreateFrame("Frame", "Background-Search-Input-box", lbsr_SearchInput, BackdropTemplateMixin and "BackdropTemplate")
lbsr_SearchInputboxBackground:SetPoint("TOP", -16, -40); lbsr_SearchInputboxBackground:SetWidth(488); lbsr_SearchInputboxBackground:SetHeight(32);
--lbsr_SearchInputboxBackground:SetFrameStrata("DIALOG")
lbsr_SearchInputboxBackground:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_SearchInputBox = CreateFrame("EditBox", nil, lbsr_SearchInputboxBackground)
lbsr_SearchInputBox:SetMaxLetters(254)
lbsr_SearchInputBox:SetPoint("CENTER", 0, 0)
lbsr_SearchInputBox:SetSize(460, 32)
lbsr_SearchInputBox:SetFont(ChatFontNormal:GetFont())
lbsr_SearchInputBox:SetAutoFocus(true)
lbsr_SearchInputBox:SetMultiLine(false)
lbsr_SearchInputBox:SetScript("OnEscapePressed", function()
		lbsr_SearchInput:Hide()
end)
lbsr_SearchInputBox:SetScript("OnEnterPressed", function()
    print("|cff3465A4" .. BOOKSTORE_SEARCH_FOR .. lbsr_SearchInputBox:GetText() .. "|r")
    BookStore_BookSearch(lbsr_SearchInputBox:GetText())
--    lbsr_SearchInput:Hide()
end)
--lbsr_SearchInputBox:Show()


local lbsr_GoSearchButton = CreateFrame("Button", nil, lbsr_SearchInput, "OptionsButtonTemplate")
lbsr_GoSearchButton = lbsr_GoSearchButton
lbsr_GoSearchButton:SetSize(40, 40)
lbsr_GoSearchButton:SetPoint("LEFT", lbsr_SearchInputboxBackground, "RIGHT", 3, 0)
lbsr_GoSearchButton:SetText("|TInterface/AddOns/Lemmos_BookStore_reborn/Artwork/MG.tga:14:14:0:0|t")
-- Textures
--lbsr_GoSearchButton:SetNormalTexture(lbsr_GoSearchButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
--lbsr_GoSearchButton:SetPushedTexture(lbsr_GoSearchButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
--lbsr_GoSearchButton:SetHighlightTexture(lbsr_GoSearchButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_GoSearchButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_GoSearchButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_GoSearchButton:SetScript("OnClick", function()
    print("|cff3465A4" .. BOOKSTORE_SEARCH_FOR .. lbsr_SearchInputBox:GetText() .. "|r")
    BookStore_BookSearch(lbsr_SearchInputBox:GetText())
    --lbsr_SearchInput:Hide()
end)

local lbsr_sCloseButton = CreateFrame("Button", nil, lbsr_SearchInput, "UIPanelCloseButton")
lbsr_sCloseButton = lbsr_sCloseButton
lbsr_sCloseButton:SetSize(32, 32)
lbsr_sCloseButton:SetPoint("TOPRIGHT", -5, -5)
lbsr_sCloseButton:SetScript("OnClick", function()
	lbsr_SearchInput:Hide()
end)

local lbsr_search_scrollFramebg = CreateFrame("Frame", nil, lbsr_SearchInput, BackdropTemplateMixin and "BackdropTemplate")
lbsr_search_scrollFramebg:SetPoint("TOP", -15, -100)
lbsr_search_scrollFramebg:SetSize(530, 471)
lbsr_search_scrollFramebg:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_search_scrollFramebarbg = CreateFrame("Frame", nil, lbsr_SearchInput, BackdropTemplateMixin and "BackdropTemplate")
lbsr_search_scrollFramebarbg:SetPoint("LEFT", lbsr_search_scrollFramebg, "RIGHT", 2, 0)
lbsr_search_scrollFramebarbg:SetSize(24, 471)
lbsr_search_scrollFramebarbg:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_search_scrollFramebarbg1 = CreateFrame("Frame", nil, lbsr_SearchInput, BackdropTemplateMixin and "BackdropTemplate")
lbsr_search_scrollFramebarbg1:SetPoint("LEFT", lbsr_search_scrollFramebg, "RIGHT", 4, 0)
lbsr_search_scrollFramebarbg1:SetSize(19, 426)
lbsr_search_scrollFramebarbg1:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 8,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_search_scrollFrame = CreateFrame("ScrollFrame", nil, lbsr_SearchInput, "UIPanelScrollFrameTemplate")
lbsr_search_scrollFrame:SetPoint("TOP", -10, -105)
lbsr_search_scrollFrame:SetSize(520, 463)
lbsr_search_scrollFrame:Show()


-- newsearch
local lbsr_searchresults = {}
local lbsr_search_resultframe = CreateFrame("Frame", "LBSR_Search-Results", lbsr_search_scrollFrame, BackdropTemplateMixin and "BackdropTemplate")
lbsr_search_resultframe:SetPoint("CENTER", 0, 0)
lbsr_search_resultframe:SetSize(520, 463)
lbsr_search_resultframe:Show()

local function lbsr_searchresultframes(resulttable)
    local lbsr_srfcount = 0
    --print(resulttable[1]['name'])
    local lbsr_srfbuttoncount = 0
    for _, entry in pairs(lbsr_searchresults)
    do
        lbsr_searchresults[lbsr_srfbuttoncount]:Hide()
        lbsr_srfbuttoncount = lbsr_srfbuttoncount + 1  
    end

    for _, entry in pairs(resulttable)
    do
        if lbsr_searchresults[lbsr_srfcount] == nil
            then
            lbsr_searchresults[lbsr_srfcount] = CreateFrame("Button", nil, lbsr_search_resultframe)
            lbsr_searchresults[lbsr_srfcount]:SetSize(500, 20)
            lbsr_searchresults[lbsr_srfcount]:SetPoint("TOPLEFT", 10, (lbsr_srfcount * (-20)))
        end
        lbsr_searchresults[lbsr_srfcount]:SetScript("OnClick", function(self)
            BookStore_OpenBook(entry['number'], true)
        end)

        local SButtonFont = lbsr_searchresults[lbsr_srfcount]:CreateFontString(nil, "OVERLAY", "GameFontNormal")
        --SButtonFont:SetFont(Game15Font:GetFont())
        SButtonFont:SetPoint("LEFT", lbsr_searchresults[lbsr_srfcount], "LEFT", 0, 0)
        SButtonFont:SetText(entry['name'])
        lbsr_searchresults[lbsr_srfcount]:SetFontString(SButtonFont)

        lbsr_searchresults[lbsr_srfcount]:Show()
        lbsr_srfcount = lbsr_srfcount + 1
    end
end
--newsearch end
lbsr_search_scrollFrame:SetScrollChild(lbsr_search_resultframe)

lbsr_SearchInput:EnableMouse(true)
lbsr_SearchInput:EnableKeyboard(true)


-- end Letter Search frames

-- Letter Export frames
lbsr_Exp_ExportFrame = CreateFrame("Frame", "LBSR_Export-Frame", UIParent, BackdropTemplateMixin and "BackdropTemplate") lbsr_Exp_ExportFrame:SetPoint("CENTER", 0, 0); lbsr_Exp_ExportFrame:SetWidth(600); lbsr_Exp_ExportFrame:SetHeight(535);
--lbsr_Exp_ExportFrame:SetFrameStrata("DIALOG")
lbsr_Exp_ExportFrame:SetToplevel(true)
lbsr_Exp_ExportFrame:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/backbig",
	tile = false,
	edgeFile = "Interface/DialogFrame/UI-DialogBox-Gold-Border",
	edgeSize = 16,
	insets = {
		left = 5,
		right = 5,
		top = 5,
		bottom = 5,
	},
})

lbsr_Exp_ExportFrame:Hide()



local lbsr_Exp_ExportFrameboxTitle = lbsr_Exp_ExportFrame:CreateFontString(nil, "OVERLAY", "GameFontNormalHugeBlack")
lbsr_Exp_ExportFrameboxTitle:SetPoint("TOP", 0, -5)
lbsr_Exp_ExportFrameboxTitle:SetSize(500, 40)
lbsr_Exp_ExportFrameboxTitle:SetTextColor(1, 1, 1, 1)
lbsr_Exp_ExportFrameboxTitle:SetText(BOOKSTORE_IMPORT_BOOK_TITLE)

local lbsr_Exp_ExportFrameboxTitledesc = lbsr_Exp_ExportFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
lbsr_Exp_ExportFrameboxTitledesc:SetPoint("TOP", 0, -30)
lbsr_Exp_ExportFrameboxTitledesc:SetSize(500, 40)
lbsr_Exp_ExportFrameboxTitledesc:SetTextColor(1, 1, 1, 1)
lbsr_Exp_ExportFrameboxTitledesc:SetText(BOOKSTORE_IMPORT_BOOK)
--lbsr_Exp_ExportFrameboxTitle:Show()

local lbsr_ExpCloseButton = CreateFrame("Button", nil, lbsr_Exp_ExportFrame, "UIPanelCloseButton")
lbsr_ExpCloseButton = lbsr_ExpCloseButton
lbsr_ExpCloseButton:SetSize(32, 32)
lbsr_ExpCloseButton:SetPoint("TOPRIGHT", -5, -5)
lbsr_ExpCloseButton:SetScript("OnClick", function()
	lbsr_Exp_ExportFrame:Hide()
end)

local lbsr_Exp_scrollFramebg = CreateFrame("Frame", nil, lbsr_Exp_ExportFrame, BackdropTemplateMixin and "BackdropTemplate")
lbsr_Exp_scrollFramebg:SetPoint("TOP", -10, -70)
lbsr_Exp_scrollFramebg:SetSize(530, 413)
lbsr_Exp_scrollFramebg:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})

local lbsr_Exp_scrollFramebarbg = CreateFrame("Frame", nil, lbsr_Exp_ExportFrame, BackdropTemplateMixin and "BackdropTemplate")
lbsr_Exp_scrollFramebarbg:SetPoint("LEFT", lbsr_Exp_scrollFramebg, "RIGHT", 2, 0)
lbsr_Exp_scrollFramebarbg:SetSize(23, 413)
lbsr_Exp_scrollFramebarbg:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 16,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})


local lbsr_Exp_scrollFramebarbg1 = CreateFrame("Frame", nil, lbsr_Exp_ExportFrame, BackdropTemplateMixin and "BackdropTemplate")
lbsr_Exp_scrollFramebarbg1:SetPoint("LEFT", lbsr_Exp_scrollFramebg, "RIGHT", 4, 0)
lbsr_Exp_scrollFramebarbg1:SetSize(19, 369)
lbsr_Exp_scrollFramebarbg1:SetBackdrop({
	bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/bggrey",
	tile = true,
	edgeFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Border",
	edgeSize = 8,
	insets = {
		left = 0,
		right = 0,
		top = 0,
		bottom = 0,
	},
})


local lbsr_Exp_scrollFrame = CreateFrame("ScrollFrame", nil, lbsr_Exp_ExportFrame, "UIPanelScrollFrameTemplate")
lbsr_Exp_scrollFrame:SetPoint("TOP", -5, -75)
lbsr_Exp_scrollFrame:SetSize(520, 405)
lbsr_Exp_scrollFrame:Show()

local lbsr_Exp_resultframe = CreateFrame("EditBox", nil, lbsr_Exp_scrollFrame)
lbsr_Exp_resultframe:SetPoint("CENTER", 0, 0)
lbsr_Exp_resultframe:SetSize(510, 405)
lbsr_Exp_resultframe:SetText("")
lbsr_Exp_resultframe:SetFont(ChatFontNormal:GetFont())
lbsr_Exp_resultframe:SetAutoFocus(true)
lbsr_Exp_resultframe:SetMultiLine(true)
lbsr_Exp_resultframe:SetScript("OnEscapePressed", function()
	lbsr_Exp_ExportFrame:Hide()
    end)
lbsr_Exp_resultframe:Show()
	
lbsr_Exp_scrollFrame:SetScrollChild(lbsr_Exp_resultframe)
lbsr_Exp_ExportFrame:EnableMouse(true)
lbsr_Exp_ExportFrame:EnableKeyboard(true)

local lbsr_ExportButton = CreateFrame("Button", nil, lbsr_Exp_ExportFrame)
lbsr_ExportButton = lbsr_ExportButton
lbsr_ExportButton:SetSize(200, 28)
lbsr_ExportButton:SetPoint("BOTTOM", 0, 16)
lbsr_ExportButton:SetText(BOOKSTORE_IMPORT_BOOK_BUTTON .. "|TInterface/AddOns/Lemmos_BookStore_reborn/Artwork/store.tga:18:18:12:0|t")
-- Textures
lbsr_ExportButton:SetNormalTexture(lbsr_ExportButton:CreateTexture(nil, nil, "DialogButtonNormalTexture"))
lbsr_ExportButton:SetPushedTexture(lbsr_ExportButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
lbsr_ExportButton:SetHighlightTexture(lbsr_ExportButton:CreateTexture(nil, nil, "DialogButtonPushedTexture"))
-- Fonts
lbsr_ExportButton:SetNormalFontObject(DialogButtonNormalText)
lbsr_ExportButton:SetHighlightFontObject(DialogButtonHighlightText)
lbsr_ExportButton:SetScript("OnClick", function()
    lbsr_Import_Book()
end)

-- end Letter Export frames

function lbsr_ToggleMoveWindows(switch)
    if switch then
        lbsr_EditLetterTitle:SetMovable(true)
        lbsr_EditLetterTitle:RegisterForDrag("LeftButton")
        lbsr_EditLetterTitle:SetScript("OnDragStart", lbsr_EditLetterTitle.StartMoving)
        lbsr_EditLetterTitle:SetScript("OnDragStop", lbsr_EditLetterTitle.StopMovingOrSizing)
        
        lbsr_SearchInput:SetMovable(true)
        lbsr_SearchInput:RegisterForDrag("LeftButton")
        lbsr_SearchInput:SetScript("OnDragStart", lbsr_SearchInput.StartMoving)
        lbsr_SearchInput:SetScript("OnDragStop", lbsr_SearchInput.StopMovingOrSizing)
        
        lbsr_Exp_ExportFrame:SetMovable(true)
        lbsr_Exp_ExportFrame:RegisterForDrag("LeftButton")
        lbsr_Exp_ExportFrame:SetScript("OnDragStart", lbsr_Exp_ExportFrame.StartMoving)
        lbsr_Exp_ExportFrame:SetScript("OnDragStop", lbsr_Exp_ExportFrame.StopMovingOrSizing)
        
        BookStoreBook:SetMovable(true)
        
        BookStoreBag:SetMovable(true)

    else
        lbsr_EditLetterTitle:SetMovable(false)
        lbsr_EditLetterTitle:RegisterForDrag(nil)
        lbsr_EditLetterTitle:SetScript("OnDragStart", nil)
        lbsr_EditLetterTitle:SetScript("OnDragStop", nil)
        
        lbsr_SearchInput:SetMovable(false)
        lbsr_SearchInput:RegisterForDrag(nil)
        lbsr_SearchInput:SetScript("OnDragStart", nil)
        lbsr_SearchInput:SetScript("OnDragStop", nil)

        lbsr_Exp_ExportFrame:SetMovable(false)
        lbsr_Exp_ExportFrame:RegisterForDrag(nil)
        lbsr_Exp_ExportFrame:SetScript("OnDragStart", nil)
        lbsr_Exp_ExportFrame:SetScript("OnDragStop", nil)

        BookStoreBook:SetMovable(false)
        
        BookStoreBag:SetMovable(false)

    end
end
-- [ FUNCTION: BookStore_PrintMsg(msg)
-- [  PURPOSE: Print a message to the default chat frame.
function BookStore_PrintMsg(msg)
   DEFAULT_CHAT_FRAME:AddMessage(msg,1,1,0);
end
-- END ]

-- [ FUNCTION: BookStore_ToolTip(slot,owner)
-- [  PURPOSE: Show a tooltip for anything else.
function BookStore_ToolTip(slot, owner)
   GameTooltip:SetOwner(owner, "ANCHOR_TOPRIGHT");
   GameTooltip:AddLine(slot, 1,1,1);
   GameTooltip:Show();
end
-- END ]

-- [ FUNCTION: BookStore_ViewTip(slot)
-- [  PURPOSE: Show a tooltip for a book.
function BookStore_ViewTip(slot)
   local actual_book = slot + ((current_shelf - 1) * BOOKS_PER_SHELF);
   local book_title = bsContainer[actual_book]["title"];
   local book_location = bsContainer[actual_book]["location"] .. " (" .. bsContainer[actual_book]["subzone"] .. ")";
   local num_of_pages_tip = table.getn(bsContainer[actual_book].pages);
   GameTooltip:SetOwner(BookStoreBag, "ANCHOR_TOPRIGHT");
   GameTooltip:AddLine(book_title, 1,1,1);
   GameTooltip:AddLine(book_location, 1,1,0);
   GameTooltip:AddLine(num_of_pages_tip .. BOOKSTORE_PAGES, 1,1,0);
   GameTooltip:Show();
   return true;
end
-- END ]

-- [ FUNCTION: BookStore_OpenBook(slot)
-- [  PURPOSE: Open a book for viewing! Woo-hoo!
function BookStore_OpenBook(slot, issearch)
   current_book = slot + ((current_shelf - 1) * BOOKS_PER_SHELF);
   BookStoreBookTitle:SetText(bsContainer[current_book].title);
   BookStoreBookAuthor:SetText(BOOKSTORE_AUTHOR .. bsContainer[current_book].author);
   BookStoreBookCreator:SetText(BOOKSTORE_CREATOR .. bsContainer[current_book].creator);
   BookStoreBookDate:SetText(bsContainer[current_book].stamp);
   BookStoreBookLocation:SetText(bsContainer[current_book].location);
   PlaySound(3190)
   if bsContainer[current_book].texture == "Bronze" then
        BookStoreBook:SetBackdrop({bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/backbr", tile = false,})
   else
        BookStoreBook:SetBackdrop({bgFile = "Interface/AddOns/Lemmos_BookStore_reborn/Artwork/back", tile = false,})
   end
   BookStoreBook:Show();
   
   local booktext = '<creator>' .. bsContainer[current_book]["creator"] .. '</creator>\n<subzone>' .. bsContainer[current_book]["subzone"] .. '</subzone>\n<author>' .. bsContainer[current_book]["author"] .. '</author>\n<stamp>' .. bsContainer[current_book]["stamp"] .. '</stamp>\n<title>' .. bsContainer[current_book]["title"] .. '</title>\n<location>' .. bsContainer[current_book]["location"] .. '</location>\n<kind>' .. bsContainer[current_book]["kind"] .. '</kind>\n<icon>' .. bsContainer[current_book]["icon"] .. '</icon>\n<texture>' .. bsContainer[current_book]["texture"] .. '</texture>\n<inbag>' .. tostring(bsContainer[current_book]["inbag"]) .. '</inbag>'
   if bsContainer[current_book]["timestamp"] ~= nil then
        booktext = booktext .. '\n<timestamp>' .. bsContainer[current_book]["timestamp"] .. '</timestamp>'
   else
        booktext = booktext .. '\n<timestamp>' .. time() .. '</timestamp>'
   end
   booktext = booktext .. '\n<pages>'
   for i, j in pairs(bsContainer[current_book]["pages"]) do
        booktext = booktext .. bsContainer[current_book]["pages"][i]["content"] .. '</nextpage/>'
   end
   booktext = booktext .. '\n</pages>'
   lbsr_Exp_resultframe:SetText(booktext)
   lbsr_Exp_resultframe:HighlightText()
--   lbsr_Exp_ExportFrame:Show()
   BookStoreTextWrap:SetText(bsContainer[current_book].pages[1].content);
   current_page = 1;
   BookStoreBookPrevPage:Hide();
   local total_pages = table.getn(bsContainer[current_book].pages)
   if( total_pages > 1 ) then
      BookStoreBookPageNumber:SetText(format(MERCHANT_PAGE_NUMBER, current_page, total_pages));
      BookStoreBookNextPage:Show();
   else
      BookStoreBookPageNumber:SetText("");
      BookStoreBookNextPage:Hide();
   end
    if ( issearch == true ) then
        BookStoreBook:ClearAllPoints()
        BookStoreBook:SetPoint("TOPRIGHT", lbsr_SearchInput, "TOPLEFT", 0, 0)
    else
        BookStoreBook:ClearAllPoints()
        BookStoreBook:SetPoint("BOTTOMRIGHT", BookStoreBag, "BOTTOMLEFT", 0, 0)
    end
end
-- END ]

-- [ FUNCTION: BookStore_CloseBook()
-- [  PURPOSE: Close a book that is currently open.
function BookStore_CloseBook()
   PlaySound(3191)
   BookStoreBook:Hide();
   BookStoreBookTitle:SetText(BOOKSTORE.Name);
   BookStoreTextWrap:SetText(BOOKSTORE.Name .. " Placeholder");
   BookStoreBookPageNumber:SetText("1");
   BookStoreBookNextPage:Hide();
   BookStoreBookPrevPage:Hide();
   current_book = 0;
   current_page = 0;
end
-- END ]

-- [ FUNCTION: BookStore_PrevPage()
-- [  PURPOSE: Display thep revious page of the book.
function BookStore_PrevPage()
   num_of_pages = table.getn(bsContainer[current_book].pages);
   if(num_of_pages>1) then
      if(current_page>1) then
         PlaySound(605)
         current_page = current_page - 1;
         BookStoreBookPageNumber:SetText(format(MERCHANT_PAGE_NUMBER, current_page, num_of_pages));
         BookStoreTextWrap:SetText(bsContainer[current_book].pages[current_page].content);
      end
      if(current_page<num_of_pages) then
         BookStoreBookNextPage:Show();
      end
   end
   if (current_page==1) then
      BookStoreBookPrevPage:Hide();
   end
end
-- END ]

-- [ FUNCTION: BookStore_NextPage()
-- [  PURPOSE: Display the next page of the book.
function BookStore_NextPage()
   num_of_pages = table.getn(bsContainer[current_book].pages);
   if (num_of_pages>1) then
      if (current_page<num_of_pages) then
         PlaySound(605)
         current_page = current_page + 1;
         BookStoreBookPageNumber:SetText(format(MERCHANT_PAGE_NUMBER, current_page, num_of_pages));
         BookStoreTextWrap:SetText(bsContainer[current_book].pages[current_page].content);
         BookStoreBookPrevPage:Show();
      end
   end
   if (current_page==num_of_pages) then
      BookStoreBookNextPage:Hide();
   end
end
-- END ]

-- [ FUNCTION: BookStore_DeleteBook()
-- [  PURPOSE: Delete a book entirely. Are you sure you want to do that?
function BookStore_DeleteBook(what)
   table.remove(bsContainer,current_book_toEdit);
   BookStore_CloseBook();
   BookStore_Refresh();
end
-- END ]

-- [ FUNCTION: BookStore_RenameBook()
-- [  PURPOSE: Rename the current Book
function BookStore_RenameBook()
    edit_entrytitle_check = bsContainer[current_book].title
    edit_entrytitle = bsContainer[current_book].title
    current_book_toEdit=current_book
    edit_existing = true
--    print(current_book_toEdit)
    lbsr_InputBoxTitle:SetText(BOOKSTORE_TITLE_CHANGE)
    lbsr_InputBox:SetText(edit_entrytitle)
    --lbsr_Exp_ExportFrame:Hide()
    --lbsr_SearchInput:Hide()
    --lbsr_DB_Import_Title:Hide()
    lbsr_EditLetterTitle:Show()
end
-- END ]

-- [ FUNCTION: BookStore_CreateBook()
-- [  PURPOSE: Create an empty book in an empty slot, ready to be populated with data.
function BookStore_CreateBook()
   local book = { title    = "",
                  author   = "",
                  creator  = UnitName("player"),
                  kind     = 0,
                  inbag    = false,
                  icon     = "",
                  texture  = "",
                  location = "",
                  subzone  = "",
                  stamp    = date(),
                  timestamp = time(),
                  pages    = {}
                }

   local total_books = table.getn( bsContainer );
   local our_pos = total_books + 1;
   bsContainer[our_pos] = book;
   return our_pos;
end
-- END ]

-- Import db

function BookStore_ImportDB(resetdb)

    if lbsr_Db_import_Data ~= nil then
        print("Importing Books from Lemmos BookStore reborn database to you\'re local Library")
        table.sort(lbsr_Db_import_Data, function(a, b)
        	return a["title"] < b["title"]
        end)
        if resetdb then
           bsContainer = {};
           BookStore_Refresh()
        end
        for i, j in pairs(lbsr_Db_import_Data) do
            lbsr_DB_import_book = {
                title        = lbsr_Db_import_Data[i]["title"],
                author       = "DB-Import",
                creator      = UnitName("player"),
                kind         = 0,
                inbag        = false,
                icon         = lbsr_Db_import_Data[i]["icon"],
                texture      = lbsr_Db_import_Data[i]["texture"],
                location     = lbsr_Db_import_Data[i]["location"],
                subzone      = lbsr_Db_import_Data[i]["subzone"],
                stamp        = date(),
                timestamp    = time(),
                pages        = lbsr_Db_import_Data[i]["pages"]
            }

            if (BookStore_BookExist(lbsr_DB_import_book["title"])) then
                lbsr_DB_import_title = lbsr_DB_import_book["title"] .." (imported)"
--                print(lbsr_DB_import_book["stamp"])
            else
                print("new: " .. lbsr_DB_import_book["title"])
                local total_books = table.getn( bsContainer );
                local our_pos = total_books + 1;
                bsContainer[our_pos] = lbsr_DB_import_book;
            end
        end
        BookStore_Refresh()
--        DisableAddOn("Lemmos_BookStore_reborn_database")
    else
        print("Lemmos BookStore reborn database not found")
    end

end

-- end Import db

function BookStore_GetBookTexture(title)
  local bag, slot;
  for bag = 0, 4 do
    if GetContainerNumSlots(bag) > 0 then
      for slot = 0, GetContainerNumSlots(bag) do
        local bookicon, _, _, _, readable = GetContainerItemInfo(bag, slot);
        if (readable) then
          if (string.find(GetContainerItemLink(bag, slot), title)) then
            return bookicon;
          end
        end
      end
    end
  end
  return "";
end

-- [ FUNCTION: BookStore_CopyBook()
-- [  PURPOSE: Duplicate an in-game book and save it to the books table.
function BookStore_CopyBook()

   local copy_title = ItemTextGetItem();
   local lbsr_isplainletter = false
   -- TODO: add customizable title if "Plain Letter".
   local lbsr_plname = GetItemInfo(8383)
   if copy_title == lbsr_plname then
        if ItemTextGetCreator() ~= nil then
            copy_title = copy_title .. " - " .. ItemTextGetCreator() .. "  " .. date()
        else
            copy_title = copy_title .. " - " .. date()
        end
        lbsr_isplainletter = true
   end
   if (BookStore_BookExist(copy_title)) then
        edit_entrytitle = copy_title;
        lbsr_IconCache = BookStore_GetBookTexture(copy_title);
        lbsr_AuthorCache = ItemTextGetCreator() or "Unknown";
        lbsr_TextureCache = ItemTextGetMaterial() or "Parchment";
        lbsr_PagesCache = {}
        while ItemTextGetPage() > 1 do
            ItemTextPrevPage();
        end
        while ItemTextHasNextPage() do
          table.insert( lbsr_PagesCache, { content = ItemTextGetText() } );
          ItemTextNextPage();
        end
        table.insert( lbsr_PagesCache, { content = ItemTextGetText() } );
        lbsr_ChangeTitleOnAdd()
        return false;
   end
   while ItemTextGetPage() > 1 do
      ItemTextPrevPage();
   end
   local total_books = table.getn( bsContainer );
   if (total_books < MAXIMUM_BOOKS) then
      local book = BookStore_CreateBook();
      local bookicon = BookStore_GetBookTexture(copy_title);
      if lbsr_isplainletter then
        bookicon = BookStore_GetBookTexture(lbsr_plname);
      end
      bsContainer[book].title    = copy_title or "Untitled";
      bsContainer[book].author   = ItemTextGetCreator() or "Unknown";
      bsContainer[book].inbag    = true;
      bsContainer[book].icon     = bookicon;
      bsContainer[book].texture  = ItemTextGetMaterial() or "Parchment";
      bsContainer[book].location = GetRealZoneText() or "Unknown Location";
      bsContainer[book].subzone  = GetMinimapZoneText() or "Unknown Location";
      while ItemTextHasNextPage() do
          table.insert( bsContainer[book].pages, { content = ItemTextGetText() } );
          ItemTextNextPage();
      end
      table.insert( bsContainer[book].pages, { content = ItemTextGetText() } );
      local book_in_shelf = BookStore_CalcBookIndex(book);
      if (BookStore_CalcBookShelf(book) == current_shelf) then
          BookStoreBagEnableItem(book_in_shelf, bookicon)
      end
      total_books = total_books + 1;
--      table.setn(bsContainer,total_books);
      BookStore_PrintMsg(bsContainer[book].title .. BOOKSTORE_ADDED); 
   else
      BookStore_Err(BOOKSTORE_FULL);
   end
   CloseItemText();
end
-- END ]

function BookStoreBagEnableItem(which, bookicon)
    local slot = getglobal("BookStoreBagItem" .. which);
    if (bookicon == "") then
        bookicon = BOOKSTORE_DEFAULT_BOOK_ICON;
    end
    slot:SetNormalTexture(bookicon);
    slot:SetPushedTexture(bookicon);
    slot:Enable();
end

-- [ FUNCTION: BookStore_CheckIsInUse(which)
-- [  PURPOSE: If the slot is in use, return true. Else, return false.
function BookStore_CheckIsInUse(which)
   if (which < (table.getn(bsContainer) + 1)) then 
      return true;
   else 
      return false;
   end
end
-- END ]

-- [ FUNCTION: BookStore_Refresh()
-- [  PURPOSE: Refresh the BookStore by disabling all buttons then re-enabling them.
function BookStore_Refresh()
   num_of_books = table.getn(bsContainer);
   for i = 1, BOOKS_PER_SHELF do
      getglobal("BookStoreBagItem" .. i):Disable();
   end
   BookStore_EnableButtons();
end
-- END ]

-- Sortbooks

function Bookstore_Sortbooks(key, asc)
    if asc then
        table.sort(bsContainer, function(a, b)
        	return a[key] < b[key]
        end)
    else
        table.sort(bsContainer, function(a, b)
        	return a[key] > b[key]
        end)
    end
    bsOptions.sortmethod = key
    bsOptions.sortascending = asc
    BookStore_Refresh()
    if bsOptions.sortmethod == "timestamp" then
        BookStoreBagSortByDate:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Button.tga")
    else
        BookStoreBagSortByDate:SetNormalTexture(nil)
    end
    if bsOptions.sortmethod == "title" then
        BookStoreBagSortByTitle:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Button.tga")
    else
        BookStoreBagSortByTitle:SetNormalTexture(nil)
    end
    if bsOptions.sortmethod == "location" then
        BookStoreBagSortByLocation:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Button.tga")
    else
        BookStoreBagSortByLocation:SetNormalTexture(nil)
    end
    if bsOptions.sortmethod == "creator" then
        BookStoreBagSortByCollector:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Button.tga")
    else
        BookStoreBagSortByCollector:SetNormalTexture(nil)
    end
    if bsOptions.sortmethod == "author" then
        BookStoreBagSortByAuthor:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/Button.tga")
    else
        BookStoreBagSortByAuthor:SetNormalTexture(nil)
    end
    if bsOptions.sortascending then
        BookStoreBagSortAsc:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/arrow_down.tga")
    else
        BookStoreBagSortAsc:SetNormalTexture("Interface/AddOns/Lemmos_BookStore_reborn/Artwork/arrow_up.tga")
    end
    BookStore_BookSearch(lbsr_SearchInputBox:GetText())
end

-- Sortbooks end

-- [ FUNCTION: BookStore_EnableButtons()
-- [  PURPOSE: Enable each book button that is in use.
function BookStore_EnableButtons()
   local book_offset = (current_shelf - 1) * BOOKS_PER_SHELF;
   for i = 1, BOOKS_PER_SHELF do
      local book = book_offset + i;
      if(BookStore_CheckIsInUse(book) == true) then 
         local slot = getglobal("BookStoreBagItem" .. i);
         local bookicon = "";
         if (bsContainer[book].icon and bsContainer[book].icon ~= "") then
            bookicon = bsContainer[book].icon;
         else
            bookicon = BOOKSTORE_DEFAULT_BOOK_ICON;
         end
         slot:SetNormalTexture(bookicon);
         slot:SetPushedTexture(bookicon);
         slot:Enable();
      end
   end
end
-- END ]

-- [ FUNCTION: BookStore_LoadMore()
-- [  PURPOSE: Initialise and load the BookStore AddOn.
function BookStore_LoadMore()
   num_of_books = table.getn(bsContainer);
   BookStore_EnableButtons();
   BookStore_PrintMsg(BOOKSTORE_INIT);
   BookStoreBagNextShelf:Show();
   if (bsOptions.visible  == false) then
      -- allow 'esc' to close
      BookStore_ToggleDisplay("toggle");
   end
   if (bsOptions.icon == nil) then
      bsOptions.icon = true
   end
   if (bsOptions.icon == false) then
      BookStore_ToggleMMIcon();
   end
   if (bsOptions.iconfixed == nil) then
      bsOptions.iconfixed = true
   end
   if (bsOptions.windowfixed == nil) then
      bsOptions.windowfixed = false
   end
   if (bsOptions.windowfixed == false) then
      lbsr_ToggleMoveWindows(true)
   end
   if (bsOptions.windowfixed == true) then
      lbsr_ToggleMoveWindows(false)
   end
   if (bsOptions.sortmethod == nil) then
      bsOptions.sortmethod = "timestamp"
   end
   if (bsOptions.sortascending == nil) then
      bsOptions.sortascending = true
   end
   Bookstore_Sortbooks(bsOptions.sortmethod, bsOptions.sortascending)
end

-- [ FUNCTION: BookStore_Load()
-- [  PURPOSE: Initialise and load the BookStore AddOn.
function BookStore_Load(self)
   bsContainer = {};
   bsOptions = {};
   self:RegisterEvent("VARIABLES_LOADED");
   self:RegisterForDrag("LeftButton");
   self:EnableMouseWheel(1);
   SLASH_BOOKSTORE1 = "/bookstore";
   SlashCmdList["BOOKSTORE"] = BookStore_HandleSlash;
end
-- END ]

-- [ FUNCTION: BookStore_ToggleDisplay()
-- [  PURPOSE: Show/Hide the BookStore 'Bag'.
function BookStore_ToggleDisplay(button)
    -- print(button)
    if button == "toggle" or button == "LeftButton" then
       local frame = getglobal("BookStoreBag");
       if (frame) then
          if( frame:IsVisible() ) then
             frame:Hide();
             bsOptions.visible = false;
             PlaySound(1278);
          else
             frame:Show();
             bsOptions.visible = true;
             PlaySound(1277);
          end
       end
   end
   if button == "MiddleButton" then
        BookStore_MM_ToggleIconFix()
        if not (lbsr_fixmmicon == nil) then
            lbsr_fixmmicon:SetChecked(bsOptions.iconfixed)
        end
   end
   if button == "RightButton" then
       	InterfaceOptionsFrame_OpenToCategory(addonName)
	    InterfaceOptionsFrame_OpenToCategory(addonName);
   end
end
-- END ]

-- [ FUNCTION: BookStore_ToggleMMIcon()
-- [  PURPOSE: Show/Hide the BookStore Mini-map Icon.
function BookStore_ToggleMMIcon()
   local mmbutton = getglobal("BookStoreMiniIcon");
--   print(mmbutton:IsVisible())
   if ( mmbutton ) then
      if( mmbutton:IsVisible() ) then
--        print("Button Wech")
         mmbutton:Hide();
         bsOptions.icon = false
      else
--        print("Button DA")
         mmbutton:Show();
         bsOptions.icon = true;
      end
      if not (lbsr_showmmicon == nil) then
          lbsr_showmmicon:SetChecked(bsOptions.icon)
      end
   end
end

function BookStore_ResetMMIcon()
    BookStoreMiniIcon:SetPoint("TOPRIGHT", -151,-64)
end


-- [ FUNCTION: BookStore_HandleSlash(command)
-- [  PURPOSE: Handle the /bookstore command and deal with it appropriately.
function BookStore_HandleSlash(command)
    if (command == "help") then
        BookStore_PrintMsg(BOOKSTORE_HELP);
    elseif( command == "options" ) then
       	InterfaceOptionsFrame_OpenToCategory(addonName)
	    InterfaceOptionsFrame_OpenToCategory(addonName);
    elseif( command == "mm" ) then
      -- Show or Hide the Mini-map Icon
        BookStore_ToggleMMIcon();
    elseif( command == "mr" ) then
        BookStore_ResetMMIcon();
    elseif( command == "mf" ) then
        BookStore_MM_ToggleIconFix()
    elseif( command == "import" ) then
        --lbsr_EditLetterTitle:Hide()
        --lbsr_Exp_ExportFrame:Hide()
        --lbsr_SearchInput:Hide()
        lbsr_DB_Import_Title:Show()
    elseif ( command:sub(1, 3) == "-f " ) then
        --Searching for a book
        local searchstring = string.format(string.reverse(string.reverse(command):sub(1, -4)))
        print("|cff3465A4" .. BOOKSTORE_SEARCH_FOR .. searchstring .. "|r")
        BookStore_BookSearch(searchstring)
        lbsr_SearchInputBox:SetText(searchstring)
        --lbsr_EditLetterTitle:Hide()
        --lbsr_DB_Import_Title:Hide()
        --lbsr_Exp_ExportFrame:Hide()
        lbsr_SearchInput:Show()
    else
      -- No command or invalid command issued, so toggle display.
        BookStore_ToggleDisplay("toggle");
    end
end
-- END ]




-- [  PURPOSE: Interface function.
function BookStore_NextShelf()
     if current_shelf == MAXIMUM_SHELVES then
          return;
     end
     BookStore_LoadShelf(current_shelf + 1);
end

-- [  PURPOSE: Interfa   local total_books = table.getn( bsContainer );ce function.
function BookStore_PrevShelf()
     if current_shelf == 1 then
          return;
     end
     BookStore_LoadShelf(current_shelf - 1);
end

-- [  PURPOSE: Support function. Loads the specified shelf.
function BookStore_LoadShelf(shelf)
    current_shelf = shelf;
    if (current_shelf == 1) then
        BookStoreBagPrevShelf:Hide();
    else
        BookStoreBagPrevShelf:Show();
    end
    if (current_shelf < MAXIMUM_SHELVES) then
        BookStoreBagNextShelf:Show();
    else
        BookStoreBagNextShelf:Hide();
    end
    BookStoreBagTitle:SetText(BOOKSTORE_SHELF .. shelf);
    -- BookStore_Err(BOOKSTORE_OPENSHELF .. shelf);
    BookStore_Refresh();
end

-- [  PURPOSE: Interface function. Support selection of book shelf using mouse wheel.
function BookStore_OnMouseWheel(self, delta)
    if (delta == -1) then
        BookStore_NextShelf();
    else
        BookStore_PrevShelf();
    end
end

-- [  PURPOSE: Support function. Returns if book title is matched exactly.
function BookStore_BookExist(title)
    for i, j in pairs(bsContainer) do
        if (bsContainer[i]["title"] == title) then 
            return true;
        end
    end
    return false;
end

-- [  PURPOSE: Support function. Returns index of first matching book.
function BookStore_BookSearch(title)
--    print(title)
    local lbsr_sresulttable = {}
    local srboxout = "<html><body><p align=\"left\">"
    local lbsr_content_found = false
    local lbsr_sresultnumber = 0
    local lbsr_pagesfound = 0
    for i, j in pairs(bsContainer) do
        lbsr_content_found = false
        for k, l in pairs(bsContainer[i]["pages"]) do
            if (string.find(string.lower(bsContainer[i]["pages"][k]["content"]), string.lower(title))) then
--                print(bsContainer[i]["pages"][k]["content"])
                lbsr_content_found = true
            end
        end           
        if (string.find(string.lower(bsContainer[i]["title"]), string.lower(title))) or lbsr_content_found then
--            BookStore_OpenBook(i)
            local shelfofbook = 0
            if floor(i / 20) == (i / 20) then
                shelfofbook = (i / 20) - 1
            else
                shelfofbook = floor(i / 20)
            end
            local bookinshelf = i - (shelfofbook * 20)
            local sractbook = "|cff73A8E1" .. BOOKSTORE_SHELF_ONLY .. " " .. (shelfofbook + 1) .. " " .. BOOKSTORE_BOOK_ONLY .. " " .. bookinshelf .. " : |r|cffFBFF89" .. bsContainer[i]["title"] .. "|r|cffD3D7CF    # " .. table.getn(bsContainer[i].pages) .. BOOKSTORE_PAGES .. "|r"
--            print(sractbook)
            srboxout = srboxout .. sractbook .. "<br/>"
--            return i;
            lbsr_sresulttable[(lbsr_sresultnumber + 1)] = {
                ['name'] = sractbook,
                ['number'] = i,
            }
            lbsr_pagesfound = lbsr_pagesfound + table.getn(bsContainer[i].pages)
            lbsr_sresultnumber = lbsr_sresultnumber + 1
        end
    end
    srboxout = srboxout .. "</p></body></html>"
    lbsr_searchresultframes(lbsr_sresulttable)
    lbsr_SearchStatistics:SetText((lbsr_sresultnumber) .. BOOKSTORE_SEARCH_STATISTICS1 .. lbsr_pagesfound .. BOOKSTORE_SEARCH_STATISTICS2)
    --lbsr_search_resultframe:SetText(srboxout)
--    return false;
end

-- [  PURPOSE: Support function. Returns position of book in shelf.
function BookStore_CalcBookIndex(book)
    return mod((book - 1), BOOKS_PER_SHELF) + 1;
end

-- [  PURPOSE: Support function. Returns shelf placed in.
function BookStore_CalcBookShelf(book)
    return floor((book - 1)/BOOKS_PER_SHELF) + 1;
end

-- [  PURPOSE: Support function. Returns true if shelf is empty.
function BookStore_IsEmptyShelf(shelf)
     if (BookStore_CalcBookShelf(table.getn(bsContainer)) >= shelf) then
          return true;
     end
     return false;
end




-- [ MINIMAP Functions

function BookStore_MM_OnLoad(self)
    self:RegisterForClicks("LeftButtonUp", "RightButtonUp");
    self:RegisterForDrag("LeftButton", "RightButton");
    BookStore_MM_Move();
end

function BookStore_MM_OnEnter()
   GameTooltip:SetOwner(BookStoreMiniIcon, "ANCHOR_BOTTOMLEFT");
   GameTooltip:AddLine("BookStore", 1,1,1);
   GameTooltip:AddLine(BOOKSTORE_MM_TOOLTIP, 0,1,0.5);
   GameTooltip:Show();
--    BookStore_ToolTip(BOOKSTORE_MM_TOOLTIP, BookStoreMiniIcon);
end

function BookStore_MM_OnLeave()
    GameTooltip:Hide();
end

function BookStore_MM_Move()
    local mmbutton = getglobal("BookStoreMiniIcon");
    if (mmbutton) then
        local xpos,ypos;
        if bsOptions.SquareMinimap then
            xpos = 110 * cos(bsOptions.IconPos or 0);
            ypos = 110 * sin(bsOptions.IconPos or 0);
            xpos = math.max(-82,math.min(xpos,84));
            ypos = math.max(-86,math.min(ypos,82));
        else
            xpos = 80*cos(bsOptions.IconPos or 0);
            ypos = 80*sin(bsOptions.IconPos or 0);
        end
        -- print((52-xpos), (ypos-52))
        mmbutton:SetPoint("TOPLEFT", "Minimap", "TOPLEFT", 52-xpos, ypos-52);
    end
end

function BookStore_MM_Drag(self)
    if (bsOptions.iconfixed == true) then
        if (self.isMoving) then
            local xpos,ypos = GetCursorPosition();
            local xmin,ymin = Minimap:GetLeft() or 400, Minimap:GetBottom() or 400;
            xpos = xmin-xpos/Minimap:GetEffectiveScale()+70;
            ypos = ypos/Minimap:GetEffectiveScale()-ymin-70;
            bsOptions.IconPos = math.deg(math.atan2(ypos,xpos));
            BookStore_MM_Move();
        end
    end
end

function BookStore_MM_ToggleIconFix()
    if (bsOptions.iconfixed == true) then
        bsOptions.iconfixed = false
    else
        bsOptions.iconfixed = true
    end
end

function BookStore_MM_Moving(self, arg1, button)
    --print(button)
    if (arg1 and button == "RightButton") then
        self:StartMoving();
        self.isMoving = true;
    else
        self:StopMovingOrSizing();
        self.isMoving = false;
    end
end

-- [ BOOK FUNCTIONS

function BookStore_CopyBook_OnLoad(self)
    getglobal(self:GetName().."Text"):SetText(BOOKSTORE_BUTTON_COPY);
end

function BookStore_DeleteBook_OnEnter()
    BookStore_ToolTip(BOOKSTORE_BUTTON_DELETE, BookStoreBookDelete);
end

function BookStore_RenameBook_OnEnter()
    BookStore_ToolTip(BOOKSTORE_BUTTON_RENAME_TOOLTIP, BookStoreBookRename);
end

function BookStore_ExportBook_OnEnter()
    BookStore_ToolTip(BOOKSTORE_BUTTON_EXPORT_TOOLTIP, BookStoreBookExport);
end

function BookStore_ImportBag_OnEnter()
    BookStore_ToolTip(BOOKSTORE_BUTTON_EXPORT_TOOLTIP, BookStoreBagImportBag);
end

function BookStore_Search_OnEnter()
    GameTooltip:SetOwner(BookStoreBagSearch, "ANCHOR_TOPLEFT");
    GameTooltip:AddLine(BOOKSTORE_SEARCH_TOOLTIP, 1,1,1);
    GameTooltip:Show();
end

function BookStore_DeleteBook_OnLeave()
    GameTooltip:Hide();
end

-- [ BOOKSTORE BOOK FUNCTIONS

function BookStore_Book_OnLoad(self)
    self:RegisterForDrag("LeftButton");
    self:EnableMouseWheel(1);
end

-- [  PURPOSE: Interface function. Support flipping of book using mouse wheel.
function BookStore_Book_OnMouseWheel(self, delta)
    if (delta == -1) then
        BookStore_NextPage();
    else
        BookStore_PrevPage();
    end
end


-- [ FUNCTION: BookStore_Err(msg)
-- [  PURPOSE: Print a message to the default error frame.
function BookStore_Err(msg)
   UIErrorsFrame:AddMessage(msg, 1.0, 1.0, 0.0, 1.0, 3);
end

function lbsr_ChangeTitleOnAdd()
    edit_existing = false
--    print(current_book_toEdit)
    lbsr_InputBoxTitle:SetText(BOOKSTORE_BUTTON_OTHERNAME)
    lbsr_InputBox:SetText(edit_entrytitle)
    --lbsr_Exp_ExportFrame:Hide()
    --lbsr_SearchInput:Hide()
    --lbsr_DB_Import_Title:Hide()
    lbsr_EditLetterTitle:Show()
end

function BookStore_deleteprepare()
    current_book_toEdit = current_book
    lbsr_DeleteTitle = bsContainer[current_book_toEdit].title
    StaticPopupDialogs["LBSR_DELETE"].text = (BOOKSTORE_BUTTON_DELETE .. "?:\n\n\"" .. lbsr_DeleteTitle .. "\"\n ")
    StaticPopup_Show("LBSR_DELETE")
end


StaticPopupDialogs["LBSR_DELETE"] = {
    text = (BOOKSTORE_BUTTON_DELETE .. "?\n" .. lbsr_DeleteTitle),
    button1 = ACCEPT,
    button2 = CANCEL,
    OnAccept = function() BookStore_DeleteBook() end,
    timeout = 0,
    whileDead = 0,
    hideOnEscape = 1
}

StaticPopupDialogs["LBSR_RENAME"] = {
    text = (BOOKSTORE_BUTTON_RENAME .. "?"),
    button1 = ACCEPT,
    button2 = CANCEL,
    OnAccept = function() lbsr_ChangeTitleOnAdd() end,
    timeout = 0,
    whileDead = 0,
    hideOnEscape = 1
}

StaticPopupDialogs["LBSR_RESET"] = {
    text = (BOOKSTORE_IMPORT_DB_RESET_CONFIRM),
    button1 = ACCEPT,
    button2 = CANCEL,
    OnAccept = function() BookStore_ImportDB(true) end,
    timeout = 0,
    whileDead = 0,
    hideOnEscape = 1
}


function lbsr_Import_Book()
    local _, creatorstart = string.find(lbsr_Exp_resultframe:GetText(), "<creator>")
    local creatorend = string.find(lbsr_Exp_resultframe:GetText(), "</creator>")
    if creatorstart == nil or creatorend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local creatorimp = string.sub(lbsr_Exp_resultframe:GetText(), (creatorstart + 1), (creatorend - 1))
--    print(creatorimp)
    local _, subzonestart = string.find(lbsr_Exp_resultframe:GetText(), "<subzone>")
    local subzoneend = string.find(lbsr_Exp_resultframe:GetText(), "</subzone>")
    if subzonestart == nil or subzoneend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local subzoneimp = string.sub(lbsr_Exp_resultframe:GetText(), (subzonestart + 1), (subzoneend - 1))
--    print(subzoneimp)
    local _, authorstart = string.find(lbsr_Exp_resultframe:GetText(), "<author>")
    local authorend = string.find(lbsr_Exp_resultframe:GetText(), "</author>")
    if authorstart == nil or authorend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local authorimp = string.sub(lbsr_Exp_resultframe:GetText(), (authorstart + 1), (authorend - 1))
--    print(authorimp)
    local _, stampstart = string.find(lbsr_Exp_resultframe:GetText(), "<stamp>")
    local stampend = string.find(lbsr_Exp_resultframe:GetText(), "</stamp>")
    if stampstart == nil or stampend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local stampimp = string.sub(lbsr_Exp_resultframe:GetText(), (stampstart + 1), (stampend - 1))
--    print(stampimp)
    local _, titlestart = string.find(lbsr_Exp_resultframe:GetText(), "<title>")
    local titleend = string.find(lbsr_Exp_resultframe:GetText(), "</title>")
    if titlestart == nil or titleend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local titleimp = string.sub(lbsr_Exp_resultframe:GetText(), (titlestart + 1), (titleend - 1))
--    print(titleimp)
    local _, locationstart = string.find(lbsr_Exp_resultframe:GetText(), "<location>")
    local locationend = string.find(lbsr_Exp_resultframe:GetText(), "</location>")
    if locationstart == nil or locationend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local locationimp = string.sub(lbsr_Exp_resultframe:GetText(), (locationstart + 1), (locationend - 1))
--    print(locationimp)
    local _, kindstart = string.find(lbsr_Exp_resultframe:GetText(), "<kind>")
    local kindend = string.find(lbsr_Exp_resultframe:GetText(), "</kind>")
    if kindstart == nil or kindend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local kindimp = tonumber(string.sub(lbsr_Exp_resultframe:GetText(), (kindstart + 1), (kindend - 1)))
--    print(kindimp)
    local _, iconstart = string.find(lbsr_Exp_resultframe:GetText(), "<icon>")
    local iconend = string.find(lbsr_Exp_resultframe:GetText(), "</icon>")
    if iconstart == nil or iconend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local iconimp = tonumber(string.sub(lbsr_Exp_resultframe:GetText(), (iconstart + 1), (iconend - 1)))
--    print(iconimp)
    local _, texturestart = string.find(lbsr_Exp_resultframe:GetText(), "<texture>")
    local textureend = string.find(lbsr_Exp_resultframe:GetText(), "</texture>")
    if texturestart == nil or textureend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local textureimp = string.sub(lbsr_Exp_resultframe:GetText(), (texturestart + 1), (textureend - 1))
--    print(textureimp)
    local _, inbagstart = string.find(lbsr_Exp_resultframe:GetText(), "<inbag>")
    local inbagend = string.find(lbsr_Exp_resultframe:GetText(), "</inbag>")
    if inbagstart == nil or inbagend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local inbagimp = false
    local inbagimptxt = string.sub(lbsr_Exp_resultframe:GetText(), (inbagstart + 1), (inbagend - 1))
        if inbagimptxt == "true" then
            inbagimp = true
        end
--    print(inbagimp)
    local _, timestampstart = string.find(lbsr_Exp_resultframe:GetText(), "<timestamp>")
    local timestampend = string.find(lbsr_Exp_resultframe:GetText(), "</timestamp>")
    if timestampstart == nil or timestampend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local timestampimp = tonumber(string.sub(lbsr_Exp_resultframe:GetText(), (timestampstart + 1), (timestampend - 1)))
--    print(timestampimp)
    local _, pagesstart = string.find(lbsr_Exp_resultframe:GetText(), "<pages>")
    local pagesend = string.find(lbsr_Exp_resultframe:GetText(), "</pages>")
    if pagesstart == nil or pagesend == nil then
        BookStore_Err("Import Error");
        return false;
    end
    local pagesimp = string.sub(lbsr_Exp_resultframe:GetText(), (pagesstart + 1), (pagesend - 1))
    local _, numofpages = string.gsub(pagesimp, "</nextpage/>", " ")
    if numofpages < 1 then
        BookStore_Err("Import Error");
        return false;
    end
    local total_books = table.getn( bsContainer );

    if (BookStore_BookExist(titleimp)) then
        BookStore_Err(titleimp .. BOOKSTORE_EXISTS);
        return false;
    end

    if (total_books < MAXIMUM_BOOKS) then
      local book = BookStore_CreateBook();
      local bookicon = iconimp;
      if bookicon == nil then
        bookicon = ""
      end
      bsContainer[book].creator  = creatorimp;
      bsContainer[book].subzone  = subzoneimp;
      bsContainer[book].author   = authorimp;
      bsContainer[book].stamp    = stampimp;
      bsContainer[book].title    = titleimp;
      bsContainer[book].location = locationimp;
      bsContainer[book].kind     = kindimp;
      bsContainer[book].icon     = bookicon;
      bsContainer[book].texture  = textureimp;
      bsContainer[book].inbag    = inbagimp;
      bsContainer[book].timestamp  = timestampimp;
        for i=1, numofpages do
            local pageend, nextpagestart = string.find(pagesimp, '</nextpage/>')
            local pagesave = string.sub(pagesimp, 0, (pageend - 1))
            table.insert( bsContainer[book].pages, { content = pagesave } );
--            print(pagesave)
            pagesimp = string.sub(pagesimp, (nextpagestart +1), -1)
        end
      local book_in_shelf = BookStore_CalcBookIndex(book);
      if (BookStore_CalcBookShelf(book) == current_shelf) then
          BookStoreBagEnableItem(book_in_shelf, bookicon)
      end
      total_books = total_books + 1;
--      table.setn(bsContainer,total_books);
      BookStore_PrintMsg(bsContainer[book].title .. BOOKSTORE_ADDED); 
   else
      BookStore_Err(BOOKSTORE_FULL);
   end

end

function lbsr_ShowExportFrame()
    --lbsr_EditLetterTitle:Hide()
    --lbsr_DB_Import_Title:Hide()
    --lbsr_SearchInput:Hide()
    lbsr_Exp_ExportFrame:Show()
    lbsr_Exp_resultframe:HighlightText()
end

function lbsr_ChangeTitle()
    if lbsr_InputBox:GetText() ~= "" then
    	edit_entrytitle = lbsr_InputBox:GetText()
	    lbsr_EditLetterTitle:Hide()
	    if edit_existing then
	        if edit_entrytitle ~= edit_entrytitle_check then
	            bsContainer[current_book_toEdit].title = edit_entrytitle
            end
            BookStore_CloseBook();
            BookStore_Refresh();
        else
            local total_books = table.getn( bsContainer );

            if (BookStore_BookExist(edit_entrytitle)) then
                BookStore_Err(edit_entrytitle .. BOOKSTORE_EXISTS);
                return false;
            end

            if (total_books < MAXIMUM_BOOKS) then
              local book = BookStore_CreateBook();
              local bookicon = lbsr_IconCache;
              bsContainer[book].subzone  = GetMinimapZoneText() or "Unknown Location";
              bsContainer[book].author   = lbsr_AuthorCache;
              bsContainer[book].title    = edit_entrytitle;
              bsContainer[book].location = GetRealZoneText() or "Unknown Location";
              bsContainer[book].icon     = bookicon;
              bsContainer[book].texture  = lbsr_TextureCache;
              bsContainer[book].inbag    = true;
              bsContainer[book].pages    = lbsr_PagesCache;
              local book_in_shelf = BookStore_CalcBookIndex(book);
              if (BookStore_CalcBookShelf(book) == current_shelf) then
                  BookStoreBagEnableItem(book_in_shelf, bookicon)
              end
              total_books = total_books + 1;
        --      table.setn(bsContainer,total_books);
              BookStore_PrintMsg(bsContainer[book].title .. BOOKSTORE_ADDED); 
           else
              BookStore_Err(BOOKSTORE_FULL);
           end
        end
    end
end

lbsr_optionsFrame.name = addonName
lbsr_optionsFrame:Hide()
lbsr_optionsFrame:SetScript("OnShow", function(lbsr_optionsFrame)
	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "LBSRCheck" .. label, lbsr_optionsFrame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = label
		check.tooltipRequirement = description
		return check
	end

	local title = lbsr_optionsFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText(addonName .. " -- v." .. BOOKSTORE.Version)

	local lbsr_resetbutton = CreateFrame("Button", "lbsr_resetbuttonFrame", lbsr_optionsFrame, "UIPanelButtonTemplate")
	lbsr_resetbutton:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	lbsr_resetbutton:SetScript("OnClick", function()
		BookStore_ResetMMIcon()
	end)
	
	lbsr_resetbutton:SetText(BOOKSTORE_MM_RESETPOSITION)
	lbsr_resetbutton:SetWidth(250)	
	
	lbsr_fixmmicon = newCheckbox(
		BOOKSTORE_MM_FIXPOSITION,
		BOOKSTORE_MM_FIXPOSITION_COMM,
		function(self, value) 
		    bsOptions.iconfixed = value
		end)
	lbsr_fixmmicon:SetChecked(bsOptions.iconfixed)
	lbsr_fixmmicon:SetPoint("TOPLEFT", lbsr_resetbutton, "BOTTOMLEFT", 0, -8)
	
	lbsr_showmmicon = newCheckbox(
		BOOKSTORE_MM_SHOWBUTTON,
		BOOKSTORE_MM_SHOWBUTTON_COMM,
		function(self, value) 
		    bsOptions.icon = value
		end)
	lbsr_showmmicon:SetChecked(bsOptions.icon)
	lbsr_showmmicon:SetPoint("TOPLEFT", lbsr_fixmmicon, "BOTTOMLEFT", 0, -8)

	lbsr_setfixwindows = newCheckbox(
		BOOKSTORE_SETWINPOSITION,
		BOOKSTORE_SETWINPOSITION_COMM,
		function(self, value) 
		    bsOptions.windowfixed = value
		    lbsr_ToggleMoveWindows(not value)
		end)
	lbsr_setfixwindows:SetChecked(bsOptions.windowfixed)
	lbsr_setfixwindows:SetPoint("TOPLEFT", lbsr_showmmicon, "BOTTOMLEFT", 0, -8)
    
	lbsr_optionsFrame:SetScript("OnShow", nil)
end)
InterfaceOptions_AddCategory(lbsr_optionsFrame)

